#!/bin/bash


mbcol=40
mbrow=03
startbit=8960
#objective='mb_tl_edge_bl_edge_sse'

workdir='/mnt/ramdisk/'

rm -f $workdir/scores.txt

#mmblist_base='40:3:-1,42:3:9061,0:7:-2:-10:-10:-10:-10:8:-5,2:7:15506,9:7:-1,15:7:16391,17:7:-1,28:7:16704,35:7:-2:-10:-10:-10:-10:8:-5,29:9:21074,34:9:-1,39:9:21626,X:22120:80,X:45038:80,X:76796:80,0:29:81738'
#mmblist_base='40:3:-1,42:3:9061'
mmblist_base=''

### statistics tables ###

table_cbpc_offset=0
table_cbpc_max=2
table_cbpc[0]=-3077
table_cbpc[1]=-447733
table_cbpc[2]=-396651

table_cbpy_offset=0
table_cbpy_max=15
table_cbpy[0]=-183827
table_cbpy[1]=-280336
table_cbpy[2]=-286789
table_cbpy[3]=-317805
table_cbpy[4]=-274273
table_cbpy[5]=-280336
table_cbpy[6]=-286789
table_cbpy[7]=-301099
table_cbpy[8]=-258021
table_cbpy[9]=-293689
table_cbpy[10]=-349650
table_cbpy[11]=-280336
table_cbpy[12]=-309104
table_cbpy[13]=-286789
table_cbpy[14]=-301099
table_cbpy[15]=-253142

table_dc_lum_offset=0
table_dc_lum_max=4
table_dc_lum[0]=-156861
table_dc_lum[1]=-114513
table_dc_lum[2]=-97077
table_dc_lum[3]=-244045
table_dc_lum[4]=-488280

table_dc_lum_level_offset=9
table_dc_lum_level_max=18
table_dc_lum_level[0]=-557594
table_dc_lum_level[1]=-557594
table_dc_lum_level[2]=-557594
table_dc_lum_level[3]=-447733
table_dc_lum_level[4]=-447733
table_dc_lum_level[5]=-418965
table_dc_lum_level[6]=-268557
table_dc_lum_level[7]=-181474
table_dc_lum_level[8]=-123214
table_dc_lum_level[9]=-9999999999999999999900000
table_dc_lum_level[10]=-144881
table_dc_lum_level[11]=-217475
table_dc_lum_level[12]=-317805
table_dc_lum_level[13]=-447733
table_dc_lum_level[14]=-447733
table_dc_lum_level[15]=-447733
table_dc_lum_level[16]=-557594
table_dc_lum_level[17]=-557594
table_dc_lum_level[18]=-557594

function compute_score {
	# compute score based on debug output
	score=0
	# get cbpc
	cbpc=`grep BITLOG:$mbcol:$mbrow:cbpc: $workdir/debug.txt | cut -d ':' -f 7`
	cbpc=$((cbpc + table_cbpc_offset))
	if [ $cbpc -lt 0 -o $cbpc -gt $table_cbpc_max ] ; then
		score=-9999999999999990
	else
		score=$((score + table_cbpc[cbpc]))
	fi
	echo "cbpc: $cbpc, score: $score"

	# get cbpy
	cbpy=`grep BITLOG:$mbcol:$mbrow:cbpy: $workdir/debug.txt | cut -d : -f 7`
	cbpy=$((cbpy + table_cbpy_offset))
	if [ $cbpy -lt 0 -o $cbpy -gt $table_cbpy_max ] ; then
		score=-9999999999999990
	else
		score=$((score + table_cbpy[cbpy]))
	fi
	echo "cbpy: $cbpy, score: $score"

	# get lum 0
	dclum0=`grep BITLOG:$mbcol:$mbrow:dc_lum:0 $workdir/debug.txt | cut -d : -f 8`
	dclum0=$((dclum0 + table_dc_lum_offset))
	if [ $dclum0 -lt 0 -o $dclum0 -gt $table_dc_lum_max ] ; then
		score=-9999999999999990
	else
		score=$((score + table_dc_lum[dclum0]))
	fi
	echo "dc_lum 0: $dclum0, score: $score"

	# get lum 1
	dclum1=`grep BITLOG:$mbcol:$mbrow:dc_lum:1 $workdir/debug.txt | cut -d : -f 8`
	dclum1=$((dclum1 + table_dc_lum_offset))
	if [ $dclum1 -lt 0 -o $dclum1 -gt $table_dc_lum_max ] ; then
		score=-9999999999999990
	else
		score=$((score + table_dc_lum[dclum1]))
	fi
	echo "dc_lum 1: $dclum1, score: $score"

	# get lum 2
	dclum2=`grep BITLOG:$mbcol:$mbrow:dc_lum:2 $workdir/debug.txt | cut -d : -f 8`
	dclum2=$((dclum2 + table_dc_lum_offset))
	if [ $dclum2 -lt 0 -o $dclum2 -gt $table_dc_lum_max ] ; then
		score=-9999999999999990
	else
		score=$((score + table_dc_lum[dclum2]))
	fi
	echo "dc_lum 2: $dclum2, score: $score"

	# get lum 3
	dclum3=`grep BITLOG:$mbcol:$mbrow:dc_lum:3 $workdir/debug.txt | cut -d : -f 8`
	dclum3=$((dclum3 + table_dc_lum_offset))
	if [ $dclum3 -lt 0 -o $dclum3 -gt $table_dc_lum_max ] ; then
		score=-9999999999999990
	else
		score=$((score + table_dc_lum[dclum3]))
	fi
	echo "dc_lum 3: $dclum3, score: $score"
}

function compare_score {
	# compares scores in ref_score and cur_score
	# sets newbetter to 1 if newscore is better than oldscore
	newbetter=0

	if [ $cur_score -gt $ref_score ] ; then
		newbetter=1
	fi
}

declare -a stack
declare -a scores
declare -a mbend
sp=1	# stack pointer, points to first free. Also count of items. TOS is one less than this.

# compute base score with nothing flipped
../FFmpeg-spacexdebug1/ffmpeg -threads 1 -debug mb_pos_size -err_detect ignore_err -s:0 704:480 -i iframe52.mpg4-img -f image2 $workdir/img2-%03d.png 2>$workdir/debug.txt

#scores[0]=`../dev/$objective $mbcol $mbrow $i <$workdir/img2-001.png`
compute_score
scores[0]=$score

echo "Initial score: $score"
echo "${scores[0]} ${mmblist_base}" >$workdir/scores2.txt

# compute initial mbend
curmbend=`grep "000:$mbcol:$mbrow" $workdir/debug.txt | sed -e "s/.*000:$mbcol:$mbrow:\([^ ]*\) \([^ ]*\).*/\1 + \2/"`
curmbend=`expr $curmbend`
mbend[0]=$curmbend

# push start bit
stack[$sp]=$startbit
sp=$((sp + 1))

# while stack not empty
while [ $sp -ne 1 ]; do
	tos=$((sp - 1))

	# DEBUG
	echo "Stack: (sp = $sp, tos = $tos)"
	for i in `seq 1 $tos` ; do
		echo "$i: ${stack[i]}"
	done

	echo "Scores:"
	for i in `seq 0 $tos` ; do
		echo "$i: ${scores[i]}"
	done

	echo "MB end:"
	for i in `seq 0 $((tos - 1))` ; do
		echo "$i: ${mbend[i]}"
	done

	# build mmblist from stack
	mmblist=$mmblist_base
	for i in `seq 1 $((tos))` ; do
		mmblist="$mmblist,X:${stack[i]}:80"
	done

	# run ffmpeg
	../FFmpeg-spacexdebug1/ffmpeg -threads 1 -mmb ${mmblist} -debug mb_pos_size -err_detect ignore_err -s:0 704:480 -i iframe52.mpg4-img -f image2 $workdir/img2-%03d.png 2>$workdir/debug.txt

	echo ${mmblist}

	# compute score
#	scores[$tos]=`../dev/$objective $mbcol $mbrow <$workdir/img2-001.png`
	compute_score
	scores[$tos]=$score

	# output score mmb
	echo "${scores[$tos]} $mmblist" >>$workdir/scores.txt

	# get end of block from debug output
	curmbend=`grep "000:$mbcol:$mbrow" $workdir/debug.txt | sed -e "s/.*000:$mbcol:$mbrow:\([^ ]*\) \([^ ]*\).*/\1 + \2/"`
	curmbend=`expr $curmbend`
#echo "score: ${scores[tos]}, cur bit: ${stack[tos]}, mbend: $curmbend"

	# if score is better
	ref_score=${scores[tos - 1]}
	cur_score=${scores[$tos]}
	compare_score
#	if [ ${scores[$tos]} -gt $ref_score ] ; then
	if [ "$newbetter" == 1 ] ; then
		# push tos
		stack[$sp]=${stack[tos]}
		scores[$sp]=${scores[tos]}
		mbend[$tos]=${curmbend}
		tos=$sp
		sp=$((sp + 1))
	fi
	# increment tos
	stack[$tos]=$((stack[tos] + 1))
	# if tos equals end of block
	if [ ${stack[$tos]} -ge $((mbend[tos - 1])) ]; then
		# pop
		sp=$((sp - 1))
		tos=$((sp - 1))
		# increment new tos to move to next bit
		stack[$tos]=$((stack[tos] + 1))
	fi
done

bestmmb=`sort $workdir/scores.txt | head -n 1`

../FFmpeg-spacexdebug1/ffmpeg -threads 1 -mmb ${bestmmb} -debug mb_pos_size -err_detect ignore_err -s:0 704:480 -i iframe52.mpg4-img -f image2 $workdir/img2-%03d.png 2>$workdir/debug.txt

echo "$bestmmb"

