#!/bin/bash
# the Great Cosmic Bit Flipper

startbit=6000
endbit=92727
numloops=10

workdir='/mnt/ramdisk'

cp iframe52.mpg4-img $workdir/cur_frame.mpg4-img
../FFmpeg-spacexdebug1/ffmpeg -threads 1 -err_detect ignore_err -s:0 704:480 -i $workdir/cur_frame.mpg4-img -f image2 $workdir/img2-%03d.png 2>$workdir/debug.txt
cur_score=`../dev/mb_jigsaw_count $workdir/img2-001.png`
#cur_score=`../dev/mb_edge_sse <$workdir/img2-001.png`

echo "first score: $cur_score"
echo "first score: $cur_score" >gcbf.out

for t in `seq 1 $numloops` ; do

	# for each bit in the file
	for cur_bit in `seq $startbit $endbit` ; do
		../dev/flip_bit $cur_bit $workdir/cur_frame.mpg4-img $workdir/try_frame.mpg4-img

		../FFmpeg-spacexdebug1/ffmpeg -threads 1 -err_detect ignore_err -s:0 704:480 -i $workdir/try_frame.mpg4-img -f image2 $workdir/img2-%03d.png 2>$workdir/debug.txt

		try_score=`../dev/mb_jigsaw_count $workdir/img2-001.png`
#		try_score=`../dev/mb_edge_sse <$workdir/img2-001.png`

		if [ $try_score -gt $cur_score -a $try_score -lt 1000000 ] ; then
#			read -p "bit: $cur_bit, cur: $cur_score, try: $try_score, Accept? " accept
			accept='y'
			if [ $accept = 'y' ] ; then
				echo "Accepted $cur_bit, cur_score = $cur_score, try_score = $try_score"
				echo "Accepted $cur_bit, cur_score = $cur_score, try_score = $try_score" >>gcbf.out
				mv $workdir/try_frame.mpg4-img $workdir/cur_frame.mpg4-img
				cur_score="$try_score"
			fi
		fi
	done
done

